/* cssbj102-2.c */
#include "csc.h" 
#include "eagle.h" 
#define Mmax (803)
unsigned long black, blue;

/* ʬۤꤹؿ */
void initial_distribution(M, L, dx, u, Gumin, Gumax)
  int M; double L, dx, *Gumin, *Gumax; double u[];
{
  int j;
  for (j = 0; j <= M; j++) { 
     u[j] = 0.0;
     if (fabs(j*dx-3.0*M_PI) < M_PI) u[j] = 1;
  }
  *Gumax = u[0]; *Gumin = u[0];
  for (j = 1; j < M; j++) {  
     if (u[j] > *Gumax) *Gumax = u[j];
     if (u[j] < *Gumin) *Gumin = u[j];
  }
  *Gumax = *Gumax*1.1; *Gumin = *Gumin - 0.1;
}

void display(M, L, u, Gumin, Gumax, lambda)
  int M; double L, Gumin, Gumax, lambda; double u[];
{  
  int j; double Umax; double xx[Mmax];

  for (j = 0; j <= M; j++) xx[j] = L/M*j;
  xx[M+1] = L; xx[M+2] = 0.0; u[M+1] = 0.0; u[M+2] = 0.0;
  w_clear();
  m_box(0.0, Gumin, L, Gumax, 0); m_line(0.0, 0.0, L, 0.0);
  set_foreground(blue);
  m_polygon(M+3, xx, u, 15);
  m_polygon(M+3, xx, u, 0);
  set_foreground(black); 
  set_line_width(1);
}

main()
{
  Window      w0;
  double      u[Mmax], u_new[Mmax];
  double      c, L, lambda, dx, dt, time, Gumin, Gumax;
  int         wx, wy, M, i, j, k, kk, ndisp, disp_interval;
  extern void initial_distribution(), display();

  L = 6.0*M_PI; M = 600; dx = L/M;
  printf("dt = "); scanf("%lf", &dt); 
  printf("c (default : 0.1) = "); scanf("%lf", &c);
  lambda = c*dt/dx;
  disp_interval = 1;

  /* ʬۤλ */
  initial_distribution(M, L, dx, u, &Gumin, &Gumax); time = 0.0;

  wx = 1000; wy = 400; 
  w0 = x_init(wx, wy, "Eagle_data");
  black = set_color(0, 0, 0);
  blue = set_color(0, 0, 255);

  m_trans_def(0.0, Gumin, L, Gumax, 20, 30, wx-40, wy-40);
  display(M, L, u, Gumin, Gumax, lambda);

  while (1) {
    printf("Input  0 for ndisp to exit\n");
    printf("      -1 for ndisp to change disp_interval\n");
    printf("Number of displays ndisp = "); scanf("%d", &ndisp);

    if (ndisp == 0) break;

    if (ndisp == -1) {
       printf("Display interval disp_interval = ");
       scanf("%d", &disp_interval);
    }

    for (k = 0; k < ndisp; k++) {
      for (kk = 0; kk < disp_interval; kk++) {
	  if (c >= 0) u_new[0] = u[0] - lambda*(u[0]-u[M-1]);
	  if (c <  0) u_new[0] = u[0] - lambda*(u[1]-u[0]);
        for (j = 1; j < M; j++) {
	    if (c >= 0) u_new[j] = u[j] - lambda*(u[j]-u[j-1]);
	    if (c <  0) u_new[j] = u[j] - lambda*(u[j+1]-u[j]);
	}
        u_new[M] = u_new[0]; 
        for (j = 0; j <= M; j++) u[j] = u_new[j];
        time = time + dt;
      }
      display(M, L, u, Gumin, Gumax, lambda);
    }
  }

  printf("Type 0 to exit "); scanf("%d", &j); /* λԤ */

  w_close(w0);
  x_term();
}

