/* cssbj52.c */
/* Finite Difference Method for Heat Equation ʱˡ*/
/* Dirichlet 0 boundary condition */
#include <stdio.h>
#include <stdlib.h>         /* Ѥ뤿Υإåե */
#include <time.h>           /* Ѥ뤿Υإåե */
#include "csc.h"     /* ͷ׻饤֥Υإåե */
#include "eagle.h" /* եå饤֥Υإåե */
#define Mmax (403)
unsigned long black, blue;  /* ̾ */

/* ʬۤꤹؿ */
void initial_distribution(M, L, dx, u, Gumin, Gumax)
  int M; double L, dx, *Gumin, *Gumax; double u[];
{
  int i, mode; double amp, tmp;
  amp = 1.0;
  printf("mode = "); scanf("%d", &mode);
  for (i = 0; i < M+1; i++) 
     u[i] = 1.0 - cos(2.0*mode*M_PI*i*dx/L) + amp*(L-i*dx)*(L-i*dx)*(i*dx)*(i*dx)/L/L/L/L;

  /*  Gumax, Gumin ϥեåΤΤ */
  *Gumax = 3.0; *Gumin = -0.1;

}

/* u(t.x) Υդؿ */
void display(M, L, u, Gumin, Gumax, lambda)
  int M; double L, Gumin, Gumax, lambda; double u[];
{  
  int i; double Umax; double xx[Mmax];

  /* ͤη׻ */
  Umax = u[0];
  for (i = 1; i <=M; i++) if (u[i] > Umax) Umax = u[i];

  for (i = 0; i <= M; i++) xx[i] = L/M*i;
  xx[M+1] = L; xx[M+2] = 0.0; u[M+1] = 0.0; u[M+2] = 0.0;
  w_clear();
  x_printf(20, 20, "lambda = %lf  Umax = %lg", lambda, Umax);
  m_box(0.0, Gumin, L, Gumax, 0); m_line(0.0, 0.0, L, 0.0);
  set_foreground(blue);
  m_polygon(M+3, xx, u, 15);
  set_line_width(3); 
  m_polygon(M+3, xx, u, 0);
  set_foreground(black); 
  set_line_width(1);
}

/* ؿ */
void SetM(M, A, B, C, lambda, a0)
  int M; double lambda, a0; double A[], B[], C[];
/*     K[i,i]   = A[i]  (i=0,...,M-1)
       K[i,i+1] = B[i]  (i=0,...,M-2)
       K[i,i-1] = C[i]  (i=1,...,M-1)    */
{
  int i;
  A[0] = 1.0/2.0+lambda; B[0] = -lambda; C[0] = 0.0;
  for (i = 1; i < M; i++) {
    A[i] = a0 + 2.0*lambda;
    B[i] = - lambda;
    C[i] = - lambda;
  }
  A[M-1] = 1.0/2.0+lambda; B[M-1] = 0.0; C[M-1] = -lambda;
}

main()
{
  Window      w0;
  double      u[Mmax], AA[Mmax], BB[Mmax], CC[Mmax];
  double      L, diff, lambda, dx, dt, time, Gumin, Gumax, Umax, usigma = 0.0;
  int         wx, wy, M, i, j, k, kk, ndisp, disp_interval, x, y, yy;
  extern void initial_distribution(), display(), SetM();

  printf("Diffusion coefficient diff = "); /* Ȼ */
  scanf("%lf", &diff);
  printf("Size of interval L = ");         /* ֤Ĺ */
  scanf("%lf", &L);
  printf("Degree of freedom M < %d, M = ", Mmax-2); /* ͳ M  */
  scanf("%d", &M);
  printf("lambda = "); scanf("%lf", &lambda); /* lambda  */
  printf("disp_interval = ");                 /* սϴֳ֤ */
  scanf("%d", &disp_interval);

  dx = L/M; dt = lambda*dx*dx/diff;
  SetM(M+1, AA, BB, CC, lambda, 1.0);         /* κ */
  LUdecomp(M+1, AA, BB, CC);                  /*  LU ʬ */

  /* ʬۤλ */
  initial_distribution(M, L, dx, u, &Gumin, &Gumax); time = 0.0;

  wx = 600; wy = 400;                /* ɥ礭λ */
  w0 = x_init(wx, wy, "Eagle_data"); /* ǽΥɥ w0 򳫤 */
  black = set_color(0, 0, 0);        /*  */
  blue = set_color(0, 0, 255);       /*  */

  /* ɸϤλ */
  m_trans_def(0.0, Gumin, L, Gumax, 20, 30, wx-40, wy-40);
  display(M, L, u, Gumin, Gumax, lambda); /* u(t.x) Υ */
  Umax = fabs(u[0]);
  for (i=0; i<M; i++)
      if (Umax < fabs(u[i])) Umax = fabs(u[i]);

  while (1) {
    printf("Input  0 for ndisp to exit\n");
    printf("      -1 for ndisp to change disp_interval\n");
    printf("      -2 for ndisp to change lambda\n");
    printf("Number of displays ndisp = ");
    scanf("%d", &ndisp);

    /* ndisp = 0 ʤ׻ */
    if (ndisp == 0) break;

    /* ndisp = -1 ʤ饰սϴֳ֤ѹ */
    if (ndisp == -1) {
       printf("Display interval disp_interval = ");
       scanf("%d", &disp_interval);
    }

    /* ndisp = -2 ʤ lambda ѹ */
    if (ndisp == -2) {
      printf("lambda  = "); scanf("%lf", &lambda);
      dt = lambda*dx*dx/diff;
      SetM(M+1, AA, BB, CC, lambda, 1.0);      /* κƺ */
      LUdecomp(M+1, AA, BB, CC);               /*  LU ʬ */
    }

    /* ndisp ǻꤵ줿ΥսϤ򤹤뤿η׻򤹤 */
    for (k = 0; k < ndisp; k++) {
      for (kk = 0; kk < disp_interval; kk++) {
        /* ʬˡˤ׻ʱˡ */
        u[0] = u[0]/2; u[M] = u[M] /2;
        LUsolve(M+1, AA, BB, CC, u);
        Umax = fabs(u[0]);
        for (i=0; i<=M; i++) {
            if (Umax < fabs(u[i])) Umax = fabs(u[i]);
	}
        for (i=1;i<M;i++) usigma += u[i];

        printf("Umax = %lf ", Umax); 
        printf("t(u[0]+u[M])/2 + dx*u[n] = %lf\n", dx*(u[0]+u[M])/2 + dx*usigma);
        usigma = 0.0;
        time = time + dt;
      }
      display(M, L, u, Gumin, Gumax, lambda);
    }
  }

  printf("Type 0 to exit "); scanf("%d", &j); /* λԤ */

  w_close(w0); /* ɥξõ */
  x_term();    /* եåνλ */
}

