/* cssbj63.c */
/* Finite Difference Method for the Fisher Equation ۲ˡ*/
/* ե뤫ǡɤ߹ */
#include "csc.h"     /* ͷ׻饤֥Υإåե */
#include "eagle.h" /* եå饤֥Υإåե */
#define Mmax (401)
unsigned long black, blue;  /* ̾ */

/* u(t.x) Υդؿ */
void display(M, L, u)
  int M; double L; double u[];
{  
  w_clear();
  m_box(0.0, -0.1, L, 1.0, 0); m_line(0.0, 0.0, L, 0.0);
  set_foreground(blue); set_line_width(3); 
  m_graph(M, 0.0, L, u);
  set_foreground(black); set_line_width(1);
}

/* 1/2Ȥʤغɸ򸡺ؿ */
double searchhalf(double dx, double u[], int M)
{
    int i;
    double length, x;

    for (i=0; i<=M; i++) {
        if (u[i] < 0.5) {
            length = dx*(0.5 - u[i])/(u[i-1] - u[i]);
            x = i*dx - length;
            return x;
        }
    }

    return 0.0;
}

main()
{
  Window      w0;
  double      u[Mmax], u_new[Mmax];
  double      L, diff, lambda, dx, dt, time;
  int         wx, wy, M, i, j, k, kk, ndisp, disp_step, shift;
  FILE        *fp; /* եݥ󥿡 */
  extern void initial_distribution(), display();
  double      x1, x2, t1, t2;
  int         flag = 0;
  double      a;

  /* ե뤫ǡɤ߹ */
  fp = fopen("result.data", "r");  /* ե򳫤 */
  fscanf(fp, "%lf %lf %lf %d %d %lf", &diff, &L, &dt, &M, &disp_step, &a);
  for (i = 0; i <= M; i++) fscanf(fp, "%lf", &u[i]); 
  fclose(fp);                      /* եĤ */

  dx = L/M; lambda = diff*dt/dx/dx;

  time = 0.0;

  wx = 600; wy = 400;                /* ɥ礭λ */
  w0 = x_init(wx, wy, "Eagle_data"); /* ǽΥɥ w0 򳫤 */
  black = set_color(0, 0, 0);        /*  */
  blue = set_color(0, 0, 255);       /*  */

  /* ɸϤλ */
  m_trans_def(0.0, -0.1, L, 1.0, 20, 30, wx-40, wy-40);

  display(M, L, u); /* u(t.x) Υդ */

  while (1) {
    printf("Input  0 for ndisp to exit\n");
    printf("Input -1 for input V\n");
    printf("Input -2 for Shift\n");
    printf("Number of displays ndisp = "); scanf("%d", &ndisp);

    /* ndisp = 0 ʤ׻ */
    if (ndisp == 0) break;

    /* ndisp = -1 ʤغɸ򸡺 */
    if (ndisp == -1) {
        if (flag == 0) {
            if((x1 = searchhalf(dx, u, M)) != 0.0) {
                t1 = time;
                flag = 1;
                printf("*****Check x1, t1*****\n");
                printf("x1 = %lf t1 = %lf\n", x1, t1);
                printf("**********************\n");
            } else {
                printf("**********************\n");
                printf("Not Get X1!!\n");
                printf("**********************\n");
            }
        } else if (flag == 1) {
            if((x2 = searchhalf(dx, u, M)) != 0.0) {
                t2 = time;
                flag = 2;
                printf("*****Check x2, t2*****\n");
                printf("x2 = %lf t2 = %lf\n", x2, t2);
                printf("**********************\n");
            } else {
                printf("**********************\n");
                printf("Not Get X2!!\n");
                printf("**********************\n");
            }
        } else if (flag == 2) {
            printf("**********************\n");
            printf("®١%lf\n", (x2 - x1) / (t2 - t1));
            printf("**********************\n");
            flag = 0;
        }
    }

    /* ndisp == -2 ʤ shift  */
    if (ndisp == -2) {
        flag = 0;
        printf("shift = "); scanf("%d", &shift);
        if (shift > 0) {
            for (i = M; i >= shift; i--) u[i] = u[i-shift];
            for (i = shift-1; i >= 0; i--) u[i] = u[shift];
        }
        if (shift < 0) {
            for (i = 0; i <= M+shift; i++) u[i] = u[i-shift];
            for (i = M+shift+1; i <= M; i++) u[i] = u[M+shift];
        }
        display(M, L, u); /* u(t.x) Υդ */
    }

    /* ndisp ǻꤵ줿ΥսϤ򤹤뤿η׻򤹤 */
    for (k = 0; k < ndisp; k++) {
      for (kk = 0; kk < disp_step; kk++) {
        if (u[i] <= a) {
          u_new[0] = (1-2*lambda)*u[0] + 2*lambda*u[1];
          u_new[0] = u_new[0]/(1-dt*u[0] + a*dt + dt*u[0]*u[0] - a*dt*u[0]);
          for (i = 1; i < M; i++) {
              u_new[i] = (1-2*lambda)*u[i] + lambda*(u[i+1]+u[i-1]);
              u_new[i] = u_new[i]/(1-dt*u[i] + a*dt + dt*u[i]*u[i] - a*dt*u[i]);
          }
          u_new[M] = (1 - 2*lambda)*u[M] + 2*lambda*u[M-1];
          u_new[M] = u_new[M] / (1-dt*u[M] + a*dt + dt*u[M]*u[M] - a*dt*u[M]);
        } else {
          u_new[0] = (-2*lambda + dt*u[0] - a*dt + 1)*u[0] + 2*lambda*u[1];
          u_new[0] = u_new[0] / (1 + dt*u[0]*u[0] - a*dt*u[0]);
          for (i = 1; i < M; i++) {
            u_new[i] = (-2*lambda+dt*u[i]-a*dt+1)*u[i] + lambda*(u[i+1]+u[i-1]);
            u_new[i] = u_new[i] / (1 + dt*u[i]*u[i] - a*dt*u[i]);
          }
          u_new[M] = (-2*lambda + dt*u[M]-a*dt+1)*u[M] + 2*lambda*u[M-1];
          u_new[M] = u_new[M] / (1 + dt*u[M]*u[M] - a*dt*u[M]);
        }
        for (i = 0; i <= M; i++) u[i] = u_new[i];
        time = time + dt;

      }
      display(M, L, u);
    }
  }

  printf("Type 0 to exit "); scanf("%d", &j); /* λԤ */
  w_close(w0); /* ɥξõ */
  x_term();    /* եåνλ */
}
