/* cssbj71.c */
/* FitzHugh-Nagumo Equation */
#include "csc.h"     /* ͷ׻饤֥Υإåե */
#include "eagle.h" /* եå饤֥Υإåե */
#define M 1003
unsigned long red, blue, black;  /* ̾ */

/* u(t.x), v(x,t) Υդؿ */
void display(u, v, N, Gmin, Gmax)
  double u[], v[]; int N; double Gmin, Gmax;
{
  w_clear(); set_line_width(1); set_foreground(black);
  m_box(0.0, Gmin, 1.0, Gmax, 0); m_line(0.0, 0.0, 1.0, 0.0);
  set_foreground(blue); set_line_width(4); m_graph(N, 0.0, 1.0, u);
  set_foreground(red);  set_line_width(2); m_graph(N, 0.0, 1.0, v);
}

main()
{
  Window w0;
  int    N, disp_interval, num_disp, ndisp, nnum, i, wx, wy;
  double aa, epsilon, gamma, L, amp1,amp2, Tmax1, Tmax2, stimulus1, stimulus2, time;
  double dx, dt, lambda, uu, vv;
  double u[M], v[M], unext[M];
  double Gmax, Gmin;
  extern void display();

  aa = 0.25; epsilon = 0.004; gamma = 6.0; /* Υѥ᡼ */
  L = 400.0;                               /* ׻ΰ */

  /* ͷ׻ѥ᡼ȷ׻ */
  N = 800; dt = 0.1; disp_interval = 60; num_disp = 300;
  dx = L/N; lambda = dt/dx/dx;

  wx = 1000; wy = 400;               /* ɥ礭λ */
  w0 = x_init(wx, wy, "Eagle_data"); /* ǽΥɥ w0 򳫤 */
  black = set_color(0, 0, 0);        /*  */
  red   = set_color(255, 0, 0);      /*  */
  blue  = set_color(0, 0, 255);      /*  */

 /* ɸϤλ */
  Gmin = -0.2; Gmax = 1.0;
  m_trans_def(0.0, Gmin, 1.0, Gmax, 10, 10, 980, 380);

  /* ʬۤλ */
  for (i = 0; i <= N; i++) { 
    u[i] = 0.0; v[i] = 0.0;
  }
  time = 0.0;

  display(u, v, N, Gmin, Gmax); /* u(t.x), v(x,t) Υդ */

  /* I(t,x)  */
  printf("Tmax1 = (std: 3.0) ? "); scanf("%lf", &Tmax1);
  printf("Tmax2 = (std: 3.0) ? "); scanf("%lf", &Tmax2);
  printf("amp1 = (std: 2.0) ? ");   scanf("%lf", &amp1);
  printf("amp2 = (std: 2.0) ? ");   scanf("%lf", &amp2);

  /* num_disp ǻꤵ줿ΥսϤ򤹤뤿η׻򤹤 */
  for (nnum = 0; nnum < num_disp; nnum++) {
    /* disp_interval ǻꤵ줿׻ */
    for (ndisp = 0; ndisp < disp_interval; ndisp++) {
      /* I(t,x) θ̤ */
      if (time <= Tmax1) stimulus1 = amp1; else stimulus1 = 0.0;
      if (time <= Tmax2) stimulus2 = amp2; else stimulus2 = 0.0;

      uu = u[0]; vv = v[0];
      unext[0] = uu + 2.0*lambda*(u[1]-uu) + dt*(uu*(1.0-uu)*(uu-aa)-vv)
                    + stimulus1*dt;
      v[0] = vv + dt*epsilon*(uu-gamma*vv);
      uu = u[N]; vv = v[N];
      unext[N] = uu + 2.0*lambda*(u[N-1]-uu) + dt*(uu*(1.0-uu)*(uu-aa)-vv) + stimulus2*dt;
      v[N] = vv + dt*epsilon*(uu-gamma*vv);
      for (i = 1; i < N; i++) {
        uu = u[i]; vv = v[i];
        unext[i] = uu + lambda*(u[i+1]+u[i-1]-2.0*uu)
        	      + dt*(uu*(1.0-uu)*(uu-aa)-vv);
	v[i] = vv + dt*epsilon*(uu-gamma*vv);
      }
      time = time + dt;
      for (i = 0; i <= N; i++) u[i] = unext[i];
    }
    display(u, v, N, Gmin, Gmax); /* u(t.x), v(x,t) Υդ */
  }
  printf("Type 0 to exit "); scanf("%d", &i); /* λԤ */
  w_close(w0); /* ɥξõ */
  x_term();    /* եåνλ */
}




