/* cssbj84.c */
#include "eagle.h"
#include "csc.h"
#define Mmax (401)
double  u_new[Mmax][Mmax], u_old[Mmax][Mmax];
unsigned long color_name[128];

void my_color_name(N)
  int N;
{
  int i, j;
  for (i = 0; i < N; i++) {
    j = i*256/N;
    color_name[    i] = set_color(0, j, 255);
    color_name[  N+i] = set_color(0, 255, 255-j);
    color_name[2*N+i] = set_color(j, 255, 0);
    color_name[3*N+i] = set_color(255, 255-j, 0);
  }
  for (i = 0; i < 4*N; i++) {
    set_foreground(color_name[i]); x_box(10, 390-3*i, 20, 3, 1);
  }
  x_printf(40, 20, "High");
  set_foreground(color_name[0]); x_printf(40, 390, "Low");
}

void display(Mx, My, N, umin, uwidth)
  int Mx, My, N; double umin, uwidth;
{  
  int i, j, k, px0, py0, dum; double ustep;
  ustep = uwidth/(N-0.000001); px0 = 10; py0 = 410;
  for (i = 1; i < Mx; i++) for (j = 1; j < My; j++) {
    k = (u_old[i][j]-umin)/ustep;
    if (k >= N) k = N-1;
    if (k <  0) k = 0;
    set_foreground(color_name[k]);
    x_box(px0+i, py0-j, 1, 1, 1);
  }
}

void initial_distribution(Mx, My, dx, dy, umin, umax, uwidth)
  int Mx, My; double dx, dy, *umin, *umax, *uwidth;
{
  int i, j;
  double x, y;
  *umax = 1.0; *umin = 0.0;
  for (i = 0; i <= Mx; i++) for (j = 0; j <= My; j++) u_old[i][j] = 0.0;
  for (i = 0; i <= Mx; i++) for (j = 0; j <= My; j++) {
    x = i*dx; y = j*dy;
    if ((x>27.5)&&(x<=32.5)&&(y>9.5)&&(y<=19.5)) u_old[i][j] = 1.0;
  }
  *uwidth = *umax - *umin;
}

/* $B78?t9TNs$r:n$k4X?t(B */
void SetM(M, A, B, C, lambda, a0)
  int M; double lambda, a0; double A[], B[], C[];
/*     K[i,i]   = A[i]  (i=0,...,M-1)
       K[i,i+1] = B[i]  (i=0,...,M-2)
       K[i,i-1] = C[i]  (i=1,...,M-1)    */
{
  int i;
  A[0] = 0.5 + lambda; B[0] = -lambda; C[0] = 0.0;
  for (i = 1; i < M; i++) {
    A[i] = a0 + 2.0*lambda;
    B[i] = - lambda;
    C[i] = - lambda;
  }
  A[M-1] = 0.5 + lambda; B[M-1] = 0.0; C[M-1] = -lambda;
}

main()
{
  Window w0, w1, w2;
  double amp;
  double Lx, Ly, diff, lamx, lamy, dx, dy, dt, dtmax, time, umin, umax, uwidth;
  int    wx, wy, Mx, My, i, j, k, kk, ndisp, disp_interval;
  int    color_base, color_number;
  double Ax[Mmax], Bx[Mmax], Cx[Mmax], Ay[Mmax], By[Mmax], Cy[Mmax];
  double u_tmp[Mmax];
  extern void initial_distribution(), my_color_name(), display();

  diff = 1.0; Lx = 200.0; Ly = 100.0; Mx = 300; My =300;
  dx = Lx/My; dy = Ly/My; 
  dtmax = (dx*dx*dy*dy)/2.0/diff/(dx*dx+dy*dy);
  if (dtmax > 0.1) dtmax = 0.1;
  printf("amp(0 < amp < 0.5) = "); scanf("%lf", &amp);
  printf("dt <= %lg in the case of explicit method, dt = ", dtmax);
  scanf("%lf", &dt); 
  lamx = diff*dt/dx/dx; lamy = diff*dt/dy/dy;

  SetM(Mx+1, Ax, Bx, Cx, lamx, 1.0); LUdecomp(Mx+1, Ax, Bx, Cx);
  SetM(My+1, Ay, By, Cy, lamy, 1.0); LUdecomp(My+1, Ay, By, Cy);

  disp_interval = 10;

  initial_distribution(Mx, My, dx, dy, &umin, &umax, &uwidth);

  wx = 550; wy = 460;
  w0 = x_init(wx, wy, "Eagle_data");
  w1 = w_open(w0, 450, 10, 90, 400);
  w2 = w_open(w0, 10, 420, 530, 30);
  color_base = 32; color_number = 4*color_base;
  w_select(w1);
  my_color_name(color_base);
  w_select(w0);

  time = 0.0;
  w_select(w2); w_clear(); set_foreground(color_name[0]);
  x_printf(10, 20, "time = %lf", time);
  w_select(w0); display(Mx, My, color_number, umin, uwidth);

  while (1) {
     printf("Input  0 for ndisp to exit\n");
     printf("      -1 for ndisp to change disp_interval\n");
     printf("Number of displays ndisp = "); 
     scanf("%d", &ndisp);
     if (ndisp == 0) break;
     if (ndisp == -1) {
        printf("Display interval disp_interval = ");
        scanf("%d", &disp_interval);
     }

     for (k = 0; k < ndisp; k++) {
       for (kk = 0; kk < disp_interval; kk++) {

         for (j = 0; j <= My; j++) {
           for (i = 0; i <= Mx; i++)
             u_tmp[i] = u_old[i][j] + dt*u_old[i][j]*(1.0-u_old[i][j])
		                                 *(u_old[i][j]-amp);
           u_tmp[0] = u_tmp[0]/2.0;          
           u_tmp[Mx] = u_tmp[Mx]/2.0;          
           LUsolve(Mx+1, Ax, Bx, Cx, u_tmp);
           for (i = 0; i <= Mx; i++) u_new[i][j] = u_tmp[i];
         }

         for (i = 0; i <= Mx; i++) for (j = 0; j <= My; j++) 
	   u_old[i][j] = u_new[i][j];

         for (i = 0; i <= Mx; i++) {
           for (j = 0; j <= My; j++)
             u_tmp[j] = u_old[i][j];
           u_tmp[0] = u_tmp[0]/2.0;          
           u_tmp[My] = u_tmp[My]/2.0;          
           LUsolve(My+1, Ay, By, Cy, u_tmp);
           for (j = 0; j <= My; j++) u_new[i][j] = u_tmp[j];
         }

         for (i = 0; i <= Mx; i++) for (j = 0; j <= My; j++) 
	   u_old[i][j] = u_new[i][j];

	 time = time + dt;

       }
       w_select(w2); w_clear(); set_foreground(color_name[0]);
       x_printf(10, 20, "time = %lf", time);
       w_select(w0); display(Mx, My, color_number, umin, uwidth);
     }
  }

  printf("Type 0 to exit "); scanf("%d", &j);
  w_close(w1); w_close(w2); w_close(w0); x_term();
}


