/* cssbj91.c */
/* FitzHugh-Nagumo Equation */
#include <string.h>
#include "csc.h"     /* ͷ׻饤֥Υإåե */
#include "eagle.h" /* եå饤֥Υإåե */
#define M 1003
unsigned long red, blue, black;  /* ̾ */

/* u(t.x), v(x,t) Υդؿ */
void display(u, v, N, Gmin, Gmax)
  double u[], v[]; int N; double Gmin, Gmax;
{
  w_clear(); set_line_width(1); set_foreground(black);
  m_box(0.0, Gmin, 1.0, Gmax, 0); m_line(0.0, 0.0, 1.0, 0.0);
  set_foreground(blue); set_line_width(4); m_graph(N, 0.0, 1.0, u);
  set_foreground(red);  set_line_width(2); m_graph(N, 0.0, 1.0, v);
}

main(int argc, char *argv[])
{
  Window w0;
  FILE *fp;
  int    N, disp_interval, num_disp, ndisp, nnum, i, wx, wy;
  double aa, epsilon, gamma, L, amp, Tmax, stimulus, time;
  double dx, dt, lambda, uu, vv;
  double u[M], v[M], unext[M];
  double Gmax, Gmin;
  extern void display();
  int flag=0;

  aa = 0.1; epsilon = 0.005; gamma = 5.0; /* Υѥ᡼ */
  L = 600.0;                               /* ׻ΰ */

  /* ͷ׻ѥ᡼ȷ׻ */
  N = 800; dt = 0.2; disp_interval = 60; num_disp = 300;
  dx = L/N; lambda = dt/dx/dx;

  wx = 1000; wy = 400;               /* ɥ礭λ */
  w0 = x_init(wx, wy, "Eagle_data"); /* ǽΥɥ w0 򳫤 */
  black = set_color(0, 0, 0);        /*  */
  red   = set_color(255, 0, 0);      /*  */
  blue  = set_color(0, 0, 255);      /*  */
 /* ɸϤλ */
  Gmin = -0.2; Gmax = 1.0;
  m_trans_def(0.0, Gmin, 1.0, Gmax, 10, 10, 980, 380);

  if (argc >= 3) {
      printf("Usage: cssbj91 [-f]\n");
      exit(1);
  } else if (argc == 2) {
      if (strcmp(argv[1],"-f") != 0) {
          printf("Usage: cssbj91 [-f]\n");
          exit(1);
      } else {
          fp = fopen("result.data", "r");
          fscanf(fp, "amp = %lf disp_interval =  %d\n", &amp, &num_disp);
          for (i = 0; i<=N; i++) fscanf(fp, "%lf %lf", &u[i], &v[i]);
          fclose(fp);
          Tmax = 0;
          flag = 1;
      }
  } else if (argc == 1) {
      for (i = 0; i <= N; i++) {
          u[i] = 0.0; v[i] = 0.0;
      }
      time = 0.0;

      /* I(t,x)  */
      printf("Tmax = (std: 3.0) ? "); scanf("%lf", &Tmax);
      printf("amp = (std: 2.0) ? ");   scanf("%lf", &amp);
  }
  display(u, v, N, Gmin, Gmax); /* u(t.x), v(x,t) Υդ */

  while (1) {
      printf("Input \" 0\" for ndisp to exit\n");
      printf("      \"-1\" for ndisp to change disp_interval\n");
      printf("      \"-2\" for ndisp to change dt\n");
      printf("      \"-3\" file output\n");
      printf("Number of displays ndisp = "); scanf("%d", &num_disp);

      /* ndisp = 0 ʤ׻ */
      if (num_disp == 0 ) break;
      /* ndisp = -1 ʤ饰սϴֳ֤ѹ */
      if (num_disp == -1) {
          printf("Display step disp_step = "); scanf("%d", &disp_interval);
      }
      /* ndisp = -2 ʤ dt ѹ */
      if (num_disp == -2) {
          printf("dt = "); scanf("%lf", &dt);
          lambda = dt/dx/dx;
      }
      /* ndisp = -3 ʤեؤν */
      if (num_disp == -3) {
          if((fp = fopen("result.data", "w")) == NULL) {
              printf("եνϤ˼Ԥޤ\n");
              printf("ϲõƤ\n");
              printf("λޤ\n");
              exit(1);
          }
          fprintf(fp, "amp = %lf disp_interval =  %d \n", amp, disp_interval); 
          for (i=0; i<=N; i++) fprintf(fp, "%lf %lf\n", u[i], v[i]);
          fclose(fp);
      }

      /* num_disp ǻꤵ줿ΥսϤ򤹤뤿η׻򤹤 */
      for (nnum = 0; nnum < num_disp; nnum++) {
          /* disp_interval ǻꤵ줿׻ */
          for (ndisp = 0; ndisp < disp_interval; ndisp++) {
              /* I(t,x) θ̤ */
              if (time <= Tmax) stimulus = amp; else stimulus = 0.0;

              uu = u[0]; vv = v[0];
              if (flag == 0) {
		  unext[0] = uu + 2.0*lambda*(u[1]-uu) + dt*(uu*(1.0-uu)*(uu-aa)-vv)
		      + stimulus*dt;
              } else {
		  unext[0] = uu + lambda*(u[1]+u[N-1]-2.0*uu) + dt*(uu*(1.0-uu)*(uu-aa)-vv);
              }
	      v[0] = vv + dt*epsilon*(uu-gamma*vv);

              uu = u[N]; vv = v[N];
	      if (flag == 0) {
		  unext[N] = uu + 2.0*lambda*(u[N-1]-uu) + dt*(uu*(1.0-uu)*(uu-aa)-vv);
	      } else {
		  unext[N] = uu + lambda*(u[1]+u[N-1]-2.0*uu) + dt*(uu*(1.0-uu)*(uu-aa)-vv);
	      }
              v[N] = vv + dt*epsilon*(uu-gamma*vv);
              for (i = 1; i < N; i++) {
                  uu = u[i]; vv = v[i];
                  unext[i] = uu + lambda*(u[i+1]+u[i-1]-2.0*uu)
                      + dt*(uu*(1.0-uu)*(uu-aa)-vv);
                  v[i] = vv + dt*epsilon*(uu-gamma*vv);
              }
              time = time + dt;
              for (i = 0; i <= N; i++) u[i] = unext[i];
          }
          display(u, v, N, Gmin, Gmax); /* u(t.x), v(x,t) Υդ
*/
      }
  }
  printf("Type 0 to exit "); scanf("%d", &i); /* λԤ */
  w_close(w0); /* ɥξõ */
  x_term();    /* եåνλ */
}
